# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Python.gitlab-ci.yml

# Official language image. Look for the different tagged releases at:
# https://hub.docker.com/r/library/python/tags/
image: python:3.10

before_script:
  - python --version ; pip --version  # For debugging
  - pip install virtualenv
  - virtualenv venv
  - source venv/bin/activate

stages:
  - code-check
  - release

flake:
  stage: code-check
  script:
    - pip install --upgrade flake8
    - flake8 .

test:
  stage: code-check
  script:
    - pip install --upgrade -r requirements.txt
    - pip install --upgrade pytest-cov typing-extensions Cython
    - python setup.py install
    - coverage run --omit="./tests/*.py,setup.py" --source=. -m unittest
    - coverage report
  coverage: '/^TOTAL.*\s+(\d+\%)$/'

publish:
  stage: release
  needs:
    - flake
    - test
  before_script:
    - '[ -z "${PYPI_API_TOKEN}" ] && (echo "PYPI_API_TOKEN variable must be set" >&2; exit 1)'
  script:
    - pip install --upgrade twine build
    - python -m build
    - TWINE_PASSWORD=$PYPI_API_TOKEN twine upload
      --verbose
      --non-interactive
      --username __token__
      dist/*

  rules:
    - if: $CI_COMMIT_BRANCH == "main"
